/**
 * \file bitmul.c
 * \brief Jednoduche cviceni pro nacvik bitovych operaci
 * \author Lukas Rucka (359687@mail.muni.cz)
 */

#include <stdio.h>
#include <stdlib.h>

unsigned int vynasob(unsigned int, unsigned int);

int main(){

    /* ZADANI:
     * mej dve cisla, ty mezi sebou vynasob pomoci
     * bitoveho posunu, zbytku po deleni a scitani
     *
     * Algoritmus:
     * Mejme dve nezaporna cisla, A a B
     * Jedna se o obdobu nasobeni pod sebou, ktere se uci v zakladni skole
     * v desitkove soustave
     *
     * A = 23 = 10111
     * B = 4  =   100
     *
     * vysledek je  0 * 10111
     *              +
     *             0  * 101110
     *              +
     *            1   * 1011100
     *
     * preteceni neres, pouzij datovy typ unsigned long, hodnoty mohou
     * byt zadratovany
     *
     */

    unsigned int a, b;
    printf("zadej dve cisla, oddelena mezerou: ");
    scanf("%u %u", &a, &b);
    printf("%u\n", vynasob(a, b));

    return EXIT_SUCCESS;
}

unsigned int vynasob(unsigned int a, unsigned int b){

    // cokoliv * 0 je 0
    if ((a & b) == 0){ return 0; }

    // maska pro izolaci posledniho bitu
    const unsigned int MASKA = 0x1;
    unsigned int vysledek = 0;

    while (b != 0){
        unsigned int bit = b & MASKA;

        if (bit){ vysledek += a; }

        a <<= 1; // posun na dalsi rad (pricitame vzdy posunuti o sloupec)
        b >>= 1; // tradicne, at nepocitame porad stejne cislo
    }

    return vysledek;
}
