/**
 * \file scitani.c
 * \brief Jednoduche cviceni pro nacvik bitovych operaci
 * \author Lukas Rucka (359687@mail.muni.cz)
 */

#include <stdio.h>
#include <stdlib.h>

unsigned int secti(unsigned int, unsigned int);

int main(){

    /* ZADANI:
     * secti dve cisla pomoci operaci bitovych posunu, bitoveho souctu
     * (binarni operator |), bitove nonekvivalence (binarni operator. ^)
     * a zbytku po deleni dvema
     *
     * Algoritmus:
     * Mejme dve nezaporna cisla, A a B
     * pro kazdy bit vysledku plati ze je nastaven, pokud je pocet jednicek
     * v prenosu, odpovidajicich bitu z cisla A a cisla B lichy. Pokud
     * je to soucasne vice nez 1, vznika prenos
     *
     * A = 23 = 10111
     * B = 4  =   100
     *
     * vysledek je  A B prenos vysledny_bit vysledny_prenos
     *              1 0 0      1            0
     *              1 0 0      1            0
     *              1 1 0      0            1
     *              0 0 1      1            0
     *              1 0 0      1            0
     *
     * vysledek: 11011
     *
     * preteceni neres, pouzij datovy typ unsigned long, hodnoty mohou
     * byt zadratovany
     *
     */

    unsigned int a, b;
    printf("zadej dve cisla, oddelena mezerou: ");
    scanf("%u %u", &a, &b);
    printf("%u\n", secti(a, b));

    return EXIT_SUCCESS;
}

unsigned int secti(unsigned int a, unsigned int b){
    unsigned int vysledek = 0;

    const unsigned int MASK = 0x1;
    unsigned int pretok = 0;

    for (int i = 0; ((a | b | pretok ) != 0); i++){
        unsigned int lsa = a & MASK;
        unsigned int lsb = b & MASK;

        vysledek |= (lsa ^ lsb ^ pretok) << i;

        pretok = ((lsa|lsb)&pretok)
                | (lsa & lsb);

        a >>= 1;
        b >>= 1;
    }

    return vysledek;
}
