/**
 * \file verbosity.c
 * \brief Jednoduche cviceni pro nacvik bitovych operaci
 * \author Lukas Rucka (359687@mail.muni.cz)
 */

#include <stdio.h>
#include <stdlib.h>

const unsigned int LOG_INFO = 1 << 0;
const unsigned int LOG_CONNECT = 1 << 1;
const unsigned int LOG_DEBUG = 1 << 2;
const unsigned int LOG_ALL = 0xff;


unsigned int testbit(unsigned int bitfield, unsigned int bitmask);

int main(){

    /* ZADANI:
     * mej ctyri konstanty, LOG_ALL, LOG_INFO, LOG_CONNECT, LOG_DEBUG
     *
     * plati: LOG_INFO, LOG_CONNECT, LOG_DEBUG nemaji zadny spolecny bit
     *        LOG_ALL ma pouze ty bity, ktere maji LOG_INFO, LOG_CONNECT, LOG_DEBUG
     *
     * dale mej sest chybovych hlaseni, po dvou pro LOG_INFO, LOG_CONNECT, LOG_DEBUG
     *
     * konkretni chybova hlaska je vypsana pouze tehdy, pokud kontrolni
     * promenna v sobe obsahuje odpovidajici konstantu
     *
     * napoveda: binarni operatory | a &
     *
     */

    unsigned int verbosity = LOG_ALL + 1;

    while (verbosity > LOG_ALL){
        printf("Zadej úroveň výpisu (0-7): ");
        scanf("%u", &verbosity);
    }

    if (testbit(verbosity, LOG_INFO)){ printf("prvni hlaska pro log info\n"); }
    if (testbit(verbosity, LOG_CONNECT)){ printf("prvni hlaska pro log connect\n"); }
    if (testbit(verbosity, LOG_DEBUG)){ printf("prvni hlaska pro log debug\n"); }
    if (testbit(verbosity, LOG_DEBUG)){ printf("druha hlaska pro log debug\n"); }
    if (testbit(verbosity, LOG_INFO)){ printf("druha hlaska pro log info\n"); }
    if (testbit(verbosity, LOG_CONNECT)){ printf("druha hlaska pro log connect\n"); }

    return EXIT_SUCCESS;
}

unsigned int testbit(unsigned int bitfield, unsigned int bitmask){
    return (bitfield & bitmask) == bitmask;
}
